#!/bin/sh
# This program is licensed under the GNU GPL version 2 or later.
-# (c) Richard "RichiH" Hartmann <richih.mailinglist@gmail.com>, 2011
+# (c) Richard "RichiH" Hartmann <richih.mailinglist@gmail.com>, 2011-2012
# For details, see LICENSE. To submit patches, you have to agree to
# license your code under the GNU GPL version 2 or later.
clone <remote> \\
[<repo>] Clone from an existing repository
- help Display this help text
delete Delete an existing repository
enter Enter repository; spawn new instance of \$SHELL
+ help Display this help text
init <repo> Initialize a new repository
list List all repositories
list-tracked List all files tracked by vcsh
run <repo> \\
<command> Use this repository
setup Set up repository with recommended settings
+ which <substring> Find substring in name of any tracked file
write-gitignore \\
<repo> Write .gitignore.d/<repo> via git ls-files
$files
AGAIN, THIS WILL DELETE YOUR DATA!
-To continue, type \"Yes, do as I say\""
+To continue, type 'Yes, do as I say'"
read answer
- [ "x$answer" = "xYes, do as I say" ] || exit 16
+ [ "x$answer" = 'xYes, do as I say' ] || exit 16
for file in $files; do
rm -f $file || info "could not delete '$file', continuing with deletion"
done
- rmdir "$GIT_DIR" || error "could not delete '$GIT_DIR'"
+ rm -r "$GIT_DIR" || error "could not delete '$GIT_DIR'"
}
enter() {
hook() {
for hook in $VCSH_HOOK_D/$1* $VCSH_HOOK_D/$VCSH_REPO_NAME.$1*; do
[ -x "$hook" ] || continue
+ info "executing '$hook'"
"$hook"
done
}
}
list() {
- for i in "$VCSH_REPO_D"/*.git; do
- echo $(basename "$i" .git)
+ for repo in "$VCSH_REPO_D"/*.git; do
+ [ -r "$repo" ] && echo $(basename "$repo" .git)
done
}
export VCSH_DIRECTORY="$VCSH_REPO_NAME"
}
+which() {
+ for VCSH_REPO_NAME in $(list); do
+ for VCSH_FILE in $(get_files); do
+ echo $VCSH_FILE | grep -q "$VCSH_COMMAND_PARAMETER" && echo "$VCSH_REPO_NAME: $VCSH_FILE"
+ done
+ done | sort -u
+}
+
write_gitignore() {
use
cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
fatal "could not move '$tempfile' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME'" 53
}
-if [ ! x$VCSH_GITIGNORE = x'exact' ] && [ ! x$VCSH_GITIGNORE = x'recursive' ]; then
- fatal "\$VCSH_GITIGNORE must be either 'exact' or 'recursive'" 1
+if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
+ fatal "'\$VCSH_GITIGNORE' must be either 'exact' or 'recursive'" 1
fi
if [ "$1" = 'clone' ]; then
- [ -z $2 ] && fatal "$1: please specify a remote" 1
+ [ -z "$2" ] && fatal "$1: please specify a remote" 1
export VCSH_COMMAND="$1"
GIT_REMOTE="$2"
[ -n "$3" ] && VCSH_REPO_NAME="$3" || VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
export VCSH_REPO_NAME
export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
-elif [ "$1" = 'delete' ] ||
- [ "$1" = 'enter' ] ||
- [ "$1" = 'init' ] ||
- [ "$1" = 'list-tracked-by' ] ||
- [ "$1" = 'rename' ] ||
- [ "$1" = 'run' ] ||
- [ "$1" = 'setup' ] ||
+elif [ "$1" = 'which' ]; then
+ [ -z "$2" ] && fatal "$1: please specify a filename" 1
+ [ -n "$3" ] && fatal "$1: too many parameters" 1
+ export VCSH_COMMAND="$1"
+ export VCSH_COMMAND_PARAMETER="$2"
+elif [ "$1" = 'delete' ] ||
+ [ "$1" = 'enter' ] ||
+ [ "$1" = 'init' ] ||
+ [ "$1" = 'list-tracked-by' ] ||
+ [ "$1" = 'rename' ] ||
+ [ "$1" = 'run' ] ||
+ [ "$1" = 'setup' ] ||
[ "$1" = 'write-gitignore' ]; then
[ -z $2 ] && fatal "$1: please specify repository to work on" 1
[ "$1" = 'rename' -a -z "$3" ] && fatal "$1: please specify a target name" 1
# Mangle the input to fit normal operation.
if echo $VCSH_REPO_NAME | grep -q '/'; then
export GIT_DIR=$VCSH_REPO_NAME
- export VCSH_REPO_NAME=$(basename $VCSH_REPO_NAME .git)
+ export VCSH_REPO_NAME=$(basename "$VCSH_REPO_NAME" .git)
fi
verbose "$VCSH_COMMAND begin"
export VCSH_COMMAND=$(echo $VCSH_COMMAND | sed 's/-/_/g')
+hook pre-command
$VCSH_COMMAND
+hook post-command
verbose "$VCSH_COMMAND end, exiting"